package org.example.eventos;

/**
 * Created by Rebeca on 08/11/2015.
 */
public class Eventos {

    private String nombre;
    private String lugar;
    private Direccion direccion;
    private Fecha fecha;
    private Hora hora;
    private String duracion;
    private String descripcion;
    private String url;
    private Coordenadas coord;

    public Eventos(String nombre, String lugar, Direccion direccion, Fecha fecha, Hora hora,
                   String duracion,String descripcion,String url, Coordenadas coord) {
        this.nombre = nombre;
        this.lugar = lugar;
        this.direccion = direccion;
        this.fecha = fecha;
        this.hora = hora;
        this.duracion = duracion;
        this.descripcion = descripcion;
        this.url = url;
        this.coord = coord;
    }

    public Eventos() {
        this.nombre = "";
        this.lugar = "";
        this.direccion = new Direccion();
        this.fecha = new Fecha();
        this.hora = new Hora();
        this.duracion = "";
        this.descripcion = "";
        this.url = "";
        this.coord = new Coordenadas();
    }

    @Override
    public String toString() {
        String cad="";
        cad+="Evento:_"+nombre+"#";
        cad+="Lugar:_"+lugar+"#";
        cad+="Direccion:_"+direccion.getTipo_calle()+"_"+direccion.getCalle()+",_"+direccion.getCalle_numero()+
                ",_"+direccion.getCiudad()+",_"+direccion.getPais()+"#";
        cad+="Fecha:_"+fecha.getDia()+"/"+fecha.getMes()+"/"+fecha.getAnyo()+"#";
        cad+="Hora:_"+hora.getHora()+":"+hora.getMinuto()+"#";
        cad+="Duracion:_"+duracion+"_minutos"+"#";
        cad+="Descripcion:_"+descripcion+"#";
        cad+="Coordenadas:_("+coord.latitud+":"+coord.longitud+")#";
        cad=cad.replace("\n","");
        cad=cad.replace(" ","");
        cad=cad.replace("\t","");
        cad=cad.replace("_"," ");
        cad=cad.replace("#","\n");
        return cad;
    }

    public Coordenadas getCoord() {
        return coord;
    }

    public void setCoord(Coordenadas coord) {
        this.coord = coord;
    }

    public String getUrl() {
        String cad = url;

        cad=cad.replace("\n","");
        cad=cad.replace(" ","");
        cad=cad.replace("\t","");
        return cad;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Hora getHora() {
        return hora;
    }

    public void setHora(Hora hora) {
        this.hora = hora;
    }

    public String getNombre() {
        String cad = "";
        Boolean dentro = false;
        for (int i=0;i<nombre.length();i++){
            if((nombre.charAt(i)==' ' || nombre.charAt(i)=='\t' || nombre.charAt(i)=='\n') && !dentro){

            } else {
                dentro = true;
                if(nombre.charAt(i)==' ') cad+='_';
                else cad+= nombre.charAt(i);
            }
        }
        //cad+=nombre;
        cad=cad.replace("\n","");
        cad=cad.replace(" ","");
        cad=cad.replace("\t","");
        cad=cad.replace("_"," ");
        cad=cad.replace("#","\n");
        return cad;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getLugar() {
        String cad = "";
        Boolean dentro = false;
        for (int i=0;i<lugar.length();i++){
            if((lugar.charAt(i)==' ' || lugar.charAt(i)=='\t' || lugar.charAt(i)=='\n') && !dentro){

            } else {
                dentro = true;
                if(lugar.charAt(i)==' ') cad+='_';
                else cad+= lugar.charAt(i);
            }
        }
        //cad+=nombre;
        cad=cad.replace("\n","");
        cad=cad.replace(" ","");
        cad=cad.replace("\t","");
        cad=cad.replace("_"," ");
        cad=cad.replace("#","\n");
        return cad;
    }

    public void setLugar(String lugar) {
        this.lugar = lugar;
    }

    public Direccion getDireccion() {
        return direccion;
    }

    public void setDireccion(Direccion direccion) {
        this.direccion = direccion;
    }

    public Fecha getFecha() {
        return fecha;
    }

    public void setFecha(Fecha fecha) {
        this.fecha = fecha;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public String getDuracion() {
        String cad = "";
        Boolean dentro = false;
        for (int i=0;i<duracion.length();i++){
            if((duracion.charAt(i)==' ' || duracion.charAt(i)=='\t' || duracion.charAt(i)=='\n') && !dentro){

            } else {
                dentro = true;
                if(duracion.charAt(i)==' ') cad+='_';
                else cad+= duracion.charAt(i);
            }
        }
        cad=cad.replace("\n","");
        cad=cad.replace(" ","");
        cad=cad.replace("\t","");
        cad=cad.replace("_"," ");
        cad=cad.replace("#","\n");
        return cad;
    }

    public void setDuracion(String duracion) {
        this.duracion = duracion;
    }
}