package org.example.eventos;

import java.util.ArrayList;
import java.util.List;

import android.app.ListActivity;
import android.content.Intent;
import android.database.MatrixCursor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextClock;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {

    private Button btnCargar;
    private TextView txtResultado;

    private List<Eventos> eventos;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.listado);
/*
        btnCargar = (Button)findViewById(R.id.btnCargar);
        txtResultado = (TextView)findViewById(R.id.txtResultado);
        btnCargar.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                CargarXmlTask tarea = new CargarXmlTask();
                tarea.execute("http://monverticalsoluciones.esy.es/eventos.xml");
            }
        });*/
        CargarXmlTask tarea = new CargarXmlTask();
        tarea.execute("http://waraia.com/eventos.xml");

    }

    public void lanzar(View view,Eventos evento) {
        Intent i = new Intent(this, EventosDetail.class );
        i.putExtra("nombre",evento.getNombre());
        i.putExtra("lugar",evento.getLugar());
        i.putExtra("direccion",evento.getDireccion().toString());
        i.putExtra("fecha",evento.getFecha().toString());
        i.putExtra("hora",evento.getHora().toString());
        i.putExtra("duracion",evento.getDuracion());
        i.putExtra("descripcion",evento.getDescripcion());
        i.putExtra("url",evento.getUrl());
        i.putExtra("lat",evento.getCoord().getLatitud().toString());
        i.putExtra("lon",evento.getCoord().getLongitud().toString());
        startActivity(i);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    //Tarea Asncrona para cargar un XML en segundo plano
    private class CargarXmlTask extends AsyncTask<String,Integer,List<Eventos>> {

        protected List<Eventos> doInBackground(String... params) {

            RssParserSax saxparser =
                    new RssParserSax(params[0]);

            eventos = saxparser.parse();

            return eventos;
        }

        protected void onPostExecute(List<Eventos> e) {

            ArrayList<ListaEntrada> datos = new ArrayList<ListaEntrada>();

            for(Eventos item: e){
                datos.add(new ListaEntrada(item));
            }

            ListView lista = (ListView) findViewById(R.id.ListView_listado);
            lista.setAdapter(new ListaAdaptador(MainActivity.this, R.layout.entrada, datos){
                @Override
                public void onEntrada(Object entrada, View view) {
                    if (entrada != null) {
                        TextView textNombre = (TextView) view.findViewById(R.id.textNombre);
                        if (textNombre != null)
                            textNombre.setText(((ListaEntrada) entrada).evento.getNombre());

                        TextView textLugar = (TextView) view.findViewById(R.id.textLugar);
                        if (textLugar != null)
                            textLugar.setText(((ListaEntrada) entrada).evento.getLugar());

                        TextView textDia = (TextView) view.findViewById(R.id.textFecha);
                        if (textDia != null)
                            textDia.setText(((ListaEntrada) entrada).evento.getFecha().toString());

                        WebView webView = (WebView) view.findViewById(R.id.webView);
                        if (webView != null)
                            webView.loadUrl(((ListaEntrada) entrada).evento.getUrl());
                    }
                }

            });

            lista.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> pariente, View view, int posicion, long id) {
                    ListaEntrada elegido = (ListaEntrada) pariente.getItemAtPosition(posicion);
/*
                    CharSequence texto = "Seleccionado: " + elegido.evento.toString();
                    Toast toast = Toast.makeText(MainActivity.this, texto, Toast.LENGTH_LONG);
                    toast.show();*/
                    lanzar(view,elegido.evento);
                }
            });

        }

/*
            //Tratamos la lista de noticias
            //Por ejemplo: escribimos los ttulos en pantalla
            txtResultado.setText("");
            Log.i("Escribir","Titulos");
            for(int i=0; i<e.size(); i++)
            {
                txtResultado.setText(
                        txtResultado.getText().toString() +
                                System.getProperty("line.separator") +
                                e.get(i).getNombre() +
                                e.get(i).getDireccion() +
                                e.get(i).getFecha());
            }*/
        }
    }
