package org.example.eventos;

import android.util.EventLogTags;
import android.util.Log;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Rebeca on 08/11/2015.
 */
public class RssHandler extends DefaultHandler {
    private List<Eventos> noticias;
    private Eventos eventoActual;
    private Direccion direccionActual;
    private Fecha fechaActual;
    private Hora hotaActual;
    private Coordenadas coordActual;
    private StringBuilder sbTexto;

    public List<Eventos> getNoticias(){
        //Log.i("GetNoticias",noticias.toString());
        return noticias;
    }

    @Override
    public void characters(char[] ch, int start, int length)
            throws SAXException {

        super.characters(ch, start, length);

        if (this.eventoActual != null)
            sbTexto.append(ch, start, length);
    }

    @Override
    public void endElement(String uri, String localName, String name)
            throws SAXException {

        super.endElement(uri, localName, name);

        if (this.eventoActual != null) {

            //Log.i("EventoActual",this.eventoActual.toString());

            if (localName.equals("Nombre")) {
                eventoActual.setNombre(sbTexto.toString());
            } else if (localName.equals("Lugar")) {
                eventoActual.setLugar(sbTexto.toString());
            } else if (localName.equals("Tipo")) {
                direccionActual.setTipo_calle(sbTexto.toString());
            } else if (localName.equals("Calle")) {
                direccionActual.setCalle(sbTexto.toString());
            } else if (localName.equals("Numero")) {
                direccionActual.setCalle_numero(sbTexto.toString());
            } else if (localName.equals("Ciudad")) {
                direccionActual.setCiudad(sbTexto.toString());
            } else if (localName.equals("Pais")) {
                direccionActual.setPais(sbTexto.toString());
            } else if (localName.equals("Direccion")) {
                eventoActual.setDireccion(direccionActual);
            } else if (localName.equals("Dia")) {
                fechaActual.setDia(sbTexto.toString());
            } else if (localName.equals("Mes")) {
                fechaActual.setMes(sbTexto.toString());
            } else if (localName.equals("Anyo")) {
                fechaActual.setAnyo(sbTexto.toString());
            } else if (localName.equals("Fecha")) {
                eventoActual.setFecha(fechaActual);
            } else if (localName.equals("Hora")) {
                hotaActual.setHora(sbTexto.toString());
            } else if (localName.equals("Minuto")) {
                hotaActual.setMinuto(sbTexto.toString());
            } else if (localName.equals("Horario")) {
                eventoActual.setHora(hotaActual);
            } else if (localName.equals("Duracion")) {
                eventoActual.setDuracion(sbTexto.toString());
            } else if (localName.equals("Descripcion")) {
                eventoActual.setDescripcion(sbTexto.toString());
            } else if (localName.equals("URL")) {
                eventoActual.setUrl(sbTexto.toString());
            } else if (localName.equals("Lat")) {
                coordActual.setLatitud(sbTexto.toString());
            } else if (localName.equals("Lon")) {
                coordActual.setLongitud(sbTexto.toString());
            } else if (localName.equals("Coord")) {
                eventoActual.setCoord(coordActual);
            } else if (localName.equals("Evento")) {
            noticias.add(eventoActual);
        }

            sbTexto.setLength(0);

            //Log.i("EventoActual:", eventoActual.toString());
            //Log.i("NoticiasEvento",noticias.toString());
        }
    }

    @Override
    public void startDocument() throws SAXException {

        super.startDocument();

        noticias = new ArrayList<Eventos>();
        sbTexto = new StringBuilder();
    }

    @Override
    public void startElement(String uri, String localName,
                             String name, Attributes attributes) throws SAXException {

        super.startElement(uri, localName, name, attributes);

        if (localName.equals("Evento")) {
            eventoActual = new Eventos();
        } else if(localName.equals("Direccion")){
            direccionActual = new Direccion();
        } else if(localName.equals("Fecha")) {
            fechaActual = new Fecha();
        } else if(localName.equals("Horario")) {
            hotaActual = new Hora();
        } else if(localName.equals("Coord")) {
            coordActual = new Coordenadas();
        }


    }
}